//IEdit Partner.  
// (c)   2002
#define _INC_OLE
#include <windows.h>
#undef _INC_OLE
#include <windowsx.h>
#include <commdlg.h>
#include <stdio.h>
#include "resource.h"

#include "zpartner.h"

#include "AdtFile.h"
#include "AdtRecord.h"
#include "PvConvert.h"

HINSTANCE g_hinst;
 // 
int isFile=0;
 //  
int isModifed=0;
 // 
char *buffer;
 //  ADT-
AdtFile mainFile;
 // ADT-
char *iDir1;
char *iDir2;
int curRec;

void toogleButton(HWND hDlg)
{/// 
	WPARAM w=TRUE;
	HWND hBut;
	
	hBut=GetDlgItem(hDlg, IDC_BUTTON_SAVE);
	if (IsWindowEnabled(hBut))
		w=FALSE;
	EnableWindow(hBut,w);
	hBut=GetDlgItem(hDlg, IDC_BUTTON_VIEW);
	EnableWindow(hBut,w);
	hBut=GetDlgItem(hDlg, IDC_BUTTON_EXPORT);
	EnableWindow(hBut,w);
	hBut=GetDlgItem(hDlg, IDC_BUTTON_IMPORT);
	EnableWindow(hBut,w);
	hBut=GetDlgItem(hDlg, IDC_BUTTON_DELETE);
	EnableWindow(hBut,w);
	hBut=GetDlgItem(hDlg, IDC_BUTTON_UP);
	EnableWindow(hBut,w);
	hBut=GetDlgItem(hDlg, IDC_BUTTON_DOWN);
	EnableWindow(hBut,w);
}

int getType(int len, unsigned char* point)
{
	if (len>=64&&point[32]==0)
	{
		char type[5];
		type[0]=point[60];
		type[1]=point[61];
		type[2]=point[62];
		type[3]=point[63];
		type[4]=0;
		if (stricmp(type,signFont)==0) return TYPE_FONT;
		if (stricmp(type,signEnc)==0) return TYPE_ENC;
		if (stricmp(type,signKeyb)==0) return TYPE_KEYB;
		if (stricmp(type,signMes)==0) return TYPE_MES;
		return TYPE_TEXT;
	}
	else
		return TYPE_TEXT;
}

char* getModuleName(int len, unsigned char* point)
{
	char *tmp1=NULL;
	char *tmp2=NULL;
	int rez,l1,l2;
	if (len>=64&&point[32]==0)
	{
		rez=getType(len,point);
		l1=strlen(msgModule[rez]);
		tmp1=new char[l1+3];
		sprintf(tmp1,"*%s:",msgModule[rez]);
		l2=strlen((char*)point);
		if (l2)
		{
			tmp2=new char[l1+l2+4];
			//memmove(tmp2,tmp1,l1+3);
			//memmove(tmp2+l1+3,point,l2);
			sprintf(tmp2,"%s%s",tmp1,(char*)point);
			delete [] tmp1;
		}
		else
			tmp2=tmp1;
		return tmp2;
	}
	tmp1=new char[1];
	tmp1[0]=0;
	return tmp1;
}

void makeList(HWND hDlg)
{//  
	HWND hList;
	int n,i;
	char *buf;
	unsigned char* tmp_buf;

	hList=GetDlgItem(hDlg, IDC_LISTBOX1);
	SendMessage(hList,LB_RESETCONTENT,0,0);
	if (mainFile.getSize())
	{
		n=mainFile.getSize();
		for(i=0; i<n; i++)
		{
			tmp_buf=mainFile[i].getData();
			if (getType(mainFile[i].getSize(),tmp_buf)==TYPE_TEXT)
			{
				buf=mainFile[i].getCaption();
				pv2win(buf);
			}
			else
			{
				buf=getModuleName(mainFile[i].getSize(),tmp_buf);
				//buf=mainFile[i].getCaption();
			}
			SendMessage(hList,LB_ADDSTRING,0,(LPARAM) buf);
			delete [] tmp_buf;
			delete [] buf;
		}
	}
}

int openFile(HWND hDlg)
{// 
	HANDLE openFile;
	OPENFILENAME ofn;

	//   
	ofn.lStructSize       = sizeof(OPENFILENAME);
	ofn.hwndOwner         = hDlg;
	ofn.hInstance         = g_hinst;
	ofn.lpstrFilter       = filterString;
	ofn.lpstrCustomFilter = NULL;
	ofn.nMaxCustFilter    = 0;
	ofn.nFilterIndex      = 0;
	ofn.lpstrFile         = buffer;
	ofn.nMaxFile          = BUFFER_SIZE;
	ofn.lpstrFileTitle    = NULL;
	ofn.nMaxFileTitle     = 0;
	ofn.lpstrInitialDir   = iDir1;
	ofn.lpstrTitle        = loadTitle;
	ofn.nFileOffset       = 0;
	ofn.nFileExtension    = 0;
	ofn.lpstrDefExt       = "adt";
	ofn.lCustData         = NULL;
	ofn.lpfnHook 		  = NULL;
	ofn.lpTemplateName    = NULL;
	ofn.Flags             = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY;
	if (GetOpenFileName(&ofn))
	{
		openFile=CreateFile(buffer,GENERIC_READ,0,NULL,OPEN_EXISTING,0,NULL);
		if (openFile==INVALID_HANDLE_VALUE)
		{
				MessageBox(hDlg,accessDenied,loadError,MB_OK | MB_ICONSTOP);
		}
		else
		{
			CloseHandle(openFile);
			if (mainFile.loadFile(buffer)) // 
			{
				return 1;
			}
			else
			{
				MessageBox(hDlg,invalidFormat,loadError,MB_OK | MB_ICONSTOP);
			}
		}
	}
	return 0;
}

int exportRecord(int num, HWND hDlg)
{//   
	int wSize=mainFile[num].getSize();
	unsigned char* exportBuffer=mainFile[num].getData();
	char buffer2[BUFFER_SIZE];
	HANDLE exportFile;
	DWORD writeCount;
	OPENFILENAME ofn;

	buffer2[0]=0;
	if (iDir2==NULL && iDir1!=NULL)
	{
		iDir2=new char[strlen(iDir1)+1];
		strcpy(iDir2,iDir1);
	}
	ofn.lStructSize       = sizeof(OPENFILENAME);
	ofn.hwndOwner         = hDlg;
	ofn.hInstance         = g_hinst;
	if (getType(mainFile[num].getSize(),exportBuffer)==TYPE_TEXT)
	{
		ofn.lpstrFilter   = filterString2;
		ofn.lpstrDefExt   = "txt";
	}
	else
	{
		ofn.lpstrFilter   = filterString3;
		ofn.lpstrDefExt   = "pdb";
	}
	ofn.lpstrCustomFilter = NULL;
	ofn.nMaxCustFilter    = 0;
	ofn.nFilterIndex      = 0;
	ofn.lpstrFile         = buffer2;
	ofn.nMaxFile          = sizeof(buffer2);
	ofn.lpstrFileTitle    = NULL;
	ofn.nMaxFileTitle     = 0;
	ofn.lpstrInitialDir   = iDir2;
	ofn.lpstrTitle        = exportTitle;
	ofn.nFileOffset       = 0;
	ofn.nFileExtension    = 0;
	ofn.lCustData         = NULL;
	ofn.lpfnHook 		  = NULL;
	ofn.lpTemplateName    = NULL;
	ofn.Flags             = OFN_EXPLORER | OFN_OVERWRITEPROMPT | OFN_HIDEREADONLY;
	if (GetSaveFileName(&ofn))
	{
					
		exportFile=CreateFile(buffer2,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,0,NULL);
		if (exportFile==INVALID_HANDLE_VALUE)
		{
			MessageBox(hDlg,exportError,exportTitle,MB_OK | MB_ICONSTOP);
			delete [] exportBuffer;
			return 0;
		}
		
		if (getType(mainFile[num].getSize(),exportBuffer)==TYPE_TEXT)
		{
			unsigned char* exportBuffer2=(unsigned char*)pv2winEx((char*)exportBuffer,wSize);
			WriteFile(exportFile,exportBuffer2,wSize,&writeCount,NULL);
			delete [] exportBuffer2;
		}
		else
			WriteFile(exportFile,exportBuffer,wSize,&writeCount,NULL);
		delete [] exportBuffer;
		CloseHandle(exportFile);
		MessageBox(hDlg,operationComplete,exportTitle,MB_OK | MB_ICONINFORMATION);
		return 1;
	}
	return 0;
}

int importRecord(HWND hDlg)
{//   
	int rSize,i,n,result;
	unsigned char* importBuffer;
	unsigned char* importBuffer2;
	HANDLE importFile;
	DWORD readCount;
	char title[BUFFER_SIZE];
	char tile[32769];
	char *buff;
	int tail_size,tile_num,beg,end;
	char buffer2[BUFFER_SIZE];
	OPENFILENAME ofn;

	buffer2[0]=0;
	if (iDir2==NULL && iDir1!=NULL)
	{
		iDir2=new char[strlen(iDir1)+1];
		strcpy(iDir2,iDir1);
	}
	ofn.lStructSize       = sizeof(OPENFILENAME);
	ofn.hwndOwner         = hDlg;
	ofn.hInstance         = g_hinst;
	ofn.lpstrFilter       = filterString4;
	ofn.lpstrCustomFilter = NULL;
	ofn.nMaxCustFilter    = 0;
	ofn.nFilterIndex      = 0;
	ofn.lpstrFile         = buffer2;
	ofn.nMaxFile          = sizeof(buffer2);
	ofn.lpstrFileTitle    = NULL;
	ofn.nMaxFileTitle     = 0;
	ofn.lpstrInitialDir   = iDir2;
	ofn.lpstrTitle        = importTitle;
	ofn.nFileOffset       = 0;
	ofn.nFileExtension    = 0;
	ofn.lpstrDefExt       = "txt";
	ofn.lCustData         = NULL;
	ofn.lpfnHook 		  = NULL;
	ofn.lpTemplateName    = NULL;
	ofn.Flags             = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY;
	if (GetOpenFileName(&ofn))
	{
		if (AdtFile::checkFile(buffer2))
		{
			AdtFile tmpFile;
			tmpFile.loadFile(buffer2);
			n=tmpFile.getSize();
			for(i=0; i<n; i++)
				mainFile.add(new AdtRecord(tmpFile[i]));
		}
		else
		{
			importFile=CreateFile(buffer2,GENERIC_READ,0,NULL,OPEN_EXISTING,0,NULL);
			if (importFile==INVALID_HANDLE_VALUE)
			{
				MessageBox(hDlg,importError,importTitle,MB_OK | MB_ICONSTOP);
				return 0;
			}

			rSize=GetFileSize(importFile,NULL);
			importBuffer=new unsigned char[rSize];

			ReadFile(importFile,importBuffer,rSize,&readCount,NULL);
			CloseHandle(importFile);
		
			if (getType(rSize,importBuffer)==TYPE_TEXT)
			{
				importBuffer2=(unsigned char*)win2pvEx((char*)importBuffer,rSize);	
				delete [] importBuffer;

				if (rSize>32768)
				{
					result=MessageBox(hDlg,splitFile,importTitle,MB_YESNO | MB_ICONQUESTION);
					if (result==IDNO)
					{
						delete [] importBuffer2;
						MessageBox(hDlg,operationCanceled,importTitle,MB_OK | MB_ICONEXCLAMATION);
						return 0;
					}
					n=strlen(buffer2);
					for(i=n-1; i>=0; i--)
						if (buffer2[i]=='\\')
							break;							
							
					strcpy(title,buffer2+i+1);
					tail_size=rSize;
					tile_num=1;
					beg=0;
					while(tail_size>0)
					{
						if (tail_size>30000)
						{
							for(end=beg+30000; (end<(beg+31000))&&(importBuffer2[end]!='\x0D'); end++)
							{}
						}
						else
						{
							end=beg+tail_size;						
						}
						buff=new char[end-beg+1];
						for(i=0; i<(end-beg); i++)
							buff[i]=importBuffer2[beg+i];
						buff[i]=0;							
						sprintf(tile,"%s - %i\x0D%s",title,tile_num,buff);
						mainFile.add(new AdtRecord(strlen(tile),(unsigned char*)tile));
						tile_num++;
						delete [] buff;
						if (tail_size>30000)
						{
							if (importBuffer2[end]=='\x0D')
							{
								tail_size-=(end-beg+1);
								beg=end+1;
							}
							else
							{
								tail_size-=(end-beg);
								beg=end;
							}
						}
						else
							tail_size=0;
					}
					delete [] importBuffer2;
				}
				else
				{
					mainFile.add(new AdtRecord(rSize,importBuffer2));
					delete [] importBuffer2;
				}
			}
			else
			{
					mainFile.add(new AdtRecord(rSize,importBuffer));
					delete [] importBuffer;
			}
		}
		MessageBox(hDlg,operationComplete,importTitle,MB_OK | MB_ICONINFORMATION);
		return 1;
	}
	return 0;
}

void viewRecord(HWND hDlg,int cursel)
{
	if (cursel!=LB_ERR)
	{
		unsigned char *tmp_buff=mainFile[cursel].getData();
		if (getType(mainFile[cursel].getSize(),tmp_buff)==TYPE_TEXT)
		{
			curRec=cursel;
			DialogBox(g_hinst, MAKEINTRESOURCE(IDD_VIEW), hDlg, (DLGPROC)ViewProc);
		}
		else
		{
			MessageBox(hDlg,viewError,viewTitle,MB_OK|MB_ICONSTOP);
		}
		delete [] tmp_buff;
	}
	else
	{
		MessageBox(hDlg,selectRecord,viewTitle,MB_OK | MB_ICONINFORMATION);
	}
}

char* prepareFilename(char* str)
{
	int n=strlen(str);
	int i,j1=0,j2=0;
	char* point;
	for(i=0; i<n; i++)
		if (str[i]=='\"')
			if (j1==0)
				j1=i+1;
			else
			{
				j2=i-1;
				break;
			}
		else
			if (str[i]==' ')
				if (j1==0)
				{
					j2=i-1;
					break;
				}
	if (j2==0)
		j2=n-1;
	if (j2>=n)
	{
		point=new char[1];
		point[0]=0;
	}
	else
	{
		point=new char[j2-j1+2];
		for(i=j1; i<=j2; i++)
			point[i-j1]=str[i];
		point[i-j1]=0;
	}
	return point;
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{// 
	char *cmdLine;

	g_hinst=hInstance;
	buffer=new char[BUFFER_SIZE];
	strcpy(buffer,fileName);
	iDir1=NULL;
	iDir2=NULL;
	cmdLine=prepareFilename(lpCmdLine);
	//MessageBox(0,cmdLine,0,MB_OK);
	if (strcmp(cmdLine,""))
	{
		if (mainFile.loadFile(cmdLine))
		{
			strcpy(buffer,cmdLine);
			DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_MAINWINDOW), NULL, (DLGPROC)DlgProc,1);
		}
		else
		{
			DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_MAINWINDOW), NULL, (DLGPROC)DlgProc,2);
		}
	}
	else
		DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_MAINWINDOW), NULL, (DLGPROC)DlgProc,0);
	delete [] cmdLine;
	delete [] buffer;
	return (FALSE);
}

BOOL CALLBACK DlgProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{// 
	int result,cursel;
	HWND hList;

	switch (uMsg)
	{
		case WM_INITDIALOG:	//
			if (lParam==1)
			{
				makeList(hDlg);
				toogleButton(hDlg);
			}
			else
				if (lParam==2)
					MessageBox(hDlg,accessDenied,loadError,MB_OK | MB_ICONSTOP);
			break;
		case WM_CLOSE:
			if (isFile&&isModifed)
			{
				if (MessageBox(hDlg,confirmExit,exitTitle,MB_YESNO | MB_ICONQUESTION)==IDNO)
					break;
			}
			EndDialog(hDlg,TRUE);
			break;
		case WM_DESTROY:	//
			break;
		case WM_COMMAND:
			switch (GET_WM_COMMAND_ID(wParam,lParam))
			{
				case IDC_BUTTON_OPEN:// 
					if (isFile)
					{//       ,     
						if (isModifed)
							result=MessageBox(hDlg,confirmSave,fileModifed,MB_YESNOCANCEL | MB_ICONQUESTION);
							if (result==IDCANCEL)// 
								break;
							else
								if (result==IDYES)
								{// 
									if (!mainFile.saveFile(buffer,"IEdit"))
									{
										MessageBox(hDlg,saveError,saveTitle,MB_OK | MB_ICONSTOP);
										break;
									}
								}
					}
					if (openFile(hDlg)) // 
					{
						isModifed=0;
						makeList(hDlg);
						if (!isFile)
							toogleButton(hDlg);
						isFile=1;
						if (mainFile.getSize())
							SendDlgItemMessage(hDlg,IDC_LISTBOX1,LB_SETCURSEL,0,0);
					}
					break;
				case IDC_BUTTON_SAVE:
					if (!mainFile.saveFile(buffer,"IEdit"))
					{
						MessageBox(hDlg,saveError, saveTitle, MB_OK | MB_ICONSTOP);
					}
					else
					{
						isModifed=0;
						MessageBox(hDlg,saveComplete, saveTitle, MB_OK | MB_ICONINFORMATION);
					}
					break;
				case IDC_BUTTON_ABOUT:
					DialogBox(g_hinst, MAKEINTRESOURCE(IDD_ABOUTBOX), hDlg, (DLGPROC)AboutProc);
					break;
				case IDC_BUTTON_EXIT:
					if (isFile&&isModifed)
					{
						if (MessageBox(hDlg,confirmExit,exitTitle,MB_YESNO | MB_ICONQUESTION)==IDNO)
							break;
					}
					EndDialog(hDlg,TRUE);
					break;

				case IDC_BUTTON_VIEW:
					hList=GetDlgItem(hDlg, IDC_LISTBOX1);
					cursel=SendMessage(hList,LB_GETCURSEL,0,0);
					viewRecord(hDlg,cursel);
					break;
				case IDC_BUTTON_EXPORT:
					hList=GetDlgItem(hDlg, IDC_LISTBOX1);
					cursel=SendMessage(hList,LB_GETCURSEL,0,0);
					if (cursel!=LB_ERR)
					{
						exportRecord(cursel,hDlg);
					}
					else
					{
						MessageBox(hDlg,selectRecord,exportTitle,MB_OK | MB_ICONINFORMATION);
					}
					break;
				case IDC_BUTTON_IMPORT:
					if (importRecord(hDlg))
					{
						makeList(hDlg);
						hList=GetDlgItem(hDlg, IDC_LISTBOX1);
						SendMessage(hList,LB_SETCURSEL,mainFile.getSize()-1,0);
						isModifed=1;
					}
					break;
				case IDC_BUTTON_DELETE:
					hList=GetDlgItem(hDlg, IDC_LISTBOX1);
					cursel=SendMessage(hList,LB_GETCURSEL,0,0);
					if (cursel!=LB_ERR)
					{
						mainFile.del(cursel);
						isModifed=1;
						makeList(hDlg);
						if (cursel==mainFile.getSize())
							SendMessage(hList,LB_SETCURSEL,cursel-1,0);
						else
							SendMessage(hList,LB_SETCURSEL,cursel,0);
					}
					else
					{
						MessageBox(hDlg,selectRecord,deleteTitle,MB_OK | MB_ICONINFORMATION);
					}
					break;
				case IDC_BUTTON_UP:
					hList=GetDlgItem(hDlg, IDC_LISTBOX1);
					cursel=SendMessage(hList,LB_GETCURSEL,0,0);
					if (cursel!=LB_ERR&&cursel)
					{
						mainFile.swap(cursel,cursel-1);
						makeList(hDlg);
						SendMessage(hList,LB_SETCURSEL,cursel-1,0);
						isModifed=1;
					}
					break;
				case IDC_BUTTON_DOWN:
					hList=GetDlgItem(hDlg, IDC_LISTBOX1);
					cursel=SendMessage(hList,LB_GETCURSEL,0,0);
					if (cursel!=LB_ERR&&(cursel!=(mainFile.getSize()-1)))
					{
						mainFile.swap(cursel,cursel+1);
						makeList(hDlg);
						SendMessage(hList,LB_SETCURSEL,cursel+1,0);
						isModifed=1;
					}
					break;
				case IDC_LISTBOX1:
					if (GET_WM_COMMAND_CMD(wParam,lParam)==LBN_DBLCLK)
					{
						hList=GetDlgItem(hDlg, IDC_LISTBOX1);
						cursel=SendMessage(hList,LB_GETCURSEL,0,0);
						viewRecord(hDlg,cursel);
					}
					break;
			}
		default:
			return (FALSE);
	}
	return (TRUE);
}

BOOL CALLBACK AboutProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
		case WM_COMMAND:
			switch (GET_WM_COMMAND_ID(wParam,lParam))
			{
				case IDOK:
					EndDialog(hDlg,TRUE);
					break;
			}
		case WM_CLOSE:
			EndDialog(hDlg,TRUE);
			break;
		default:
			return (FALSE);
	}
	return (TRUE);
}

BOOL CALLBACK ViewProc(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	int i,size;
	char *bf1,*bf2;
	HWND hEdit;

	switch (uMsg)
	{
		case WM_INITDIALOG:	//
			bf1=(char*)(mainFile[curRec].getData());
			size=mainFile[curRec].getSize();
			bf2=pv2winEx(bf1,size);
			delete [] bf1;
			bf1=new char[size+1];
			for(i=0; i<size; i++)
				bf1[i]=bf2[i];
			bf1[i]=0;
			delete [] bf2;
			hEdit=GetDlgItem(hDlg, IDC_EDIT1);			
			SendMessage(hEdit,WM_SETTEXT,0,(LPARAM)bf1);
			delete [] bf1;
			break;
		case WM_CLOSE:
			EndDialog(hDlg,TRUE);
			break;
		case WM_SIZE:
			RECT rSize;
			long bW,bH,bW2,bH2;
			hEdit=GetDlgItem(hDlg, IDC_EDIT1);
			MoveWindow(hEdit, 0, 0, LOWORD(lParam), HIWORD(lParam)-26, FALSE);
			hEdit=GetDlgItem(hDlg, IDC_CLOSE);
			GetWindowRect(hEdit,&rSize);
			bW=rSize.right-rSize.left;
			bH=rSize.bottom-rSize.top;
			MoveWindow(hEdit, LOWORD(lParam)-75, HIWORD(lParam)-23,bW,bH, FALSE);
			hEdit=GetDlgItem(hDlg, IDC_EXPORT2);
			GetWindowRect(hEdit,&rSize);
			bW2=rSize.right-rSize.left;
			bH2=rSize.bottom-rSize.top;
			MoveWindow(hEdit, LOWORD(lParam)-75-bW, HIWORD(lParam)-23,bW2,bH2, FALSE);
			rSize.left=0;
			rSize.top=0;
			rSize.right=LOWORD(lParam);
			rSize.bottom=HIWORD(lParam);
			InvalidateRect(hDlg,&rSize,TRUE);
			UpdateWindow(hDlg);
			break;
		case WM_COMMAND:
			switch (GET_WM_COMMAND_ID(wParam,lParam))
			{
				case IDC_CLOSE:
					EndDialog(hDlg,TRUE);
					break;
				case IDC_EXPORT2:
					if (exportRecord(curRec,hDlg))
						EndDialog(hDlg,TRUE);
					break;
			}
			break;
		default:
			return (FALSE);
	}
	return (TRUE);
}