// (c)   2002

#ifndef _LERM_ADT_FILE_H_
#define _LERM_ADT_FILE_H_

#include "AdtRecord.h"

class AdtFile  
{
	//!============!
	public:
	AdtFile();
	~AdtFile();

	int loadFile(const char* fname);
		// adt-
	int saveFile(const char* fname, const char* adtname);
		// adt-
	static int checkFile(const char*);
		// adt-


	AdtRecord& operator [] (int num){return *(point[num]);}
	int getSize(){return size;}

	int add(AdtRecord* rec);
	int del(int num);
	int delAll();
	void swap(int num1, int num2);

	//!============!
	protected:

	void code(unsigned char* seq, int slen);

	static unsigned char mask[20];	//

	int size;
	AdtRecord **point;
};

#endif