// (c)   2002

#include "PvTable.h"
#include <windows.h>

void pv2win(char* str)
{//   PV-RUS  CP1251
	int n=strlen(str),i;
	for(i=0; i<n; i++)
		str[i]=pv2ansi[(unsigned char)str[i]];
}

void win2pv(char* str)
{//   CP-1251  PV-RUS
	int n=strlen(str),i;
	for(i=0; i<n; i++)
		str[i]=ansi2pv[(unsigned char)str[i]];

}

char* pv2winEx(char* str, int& size)
{
	int n=size,i,j,n2;
	char* point;
	for(i=0,j=0; i<n; i++)
		if (str[i]=='\x0D')
			j++;
	n2=n+j;
	point=new char[n2];
	for(i=0,j=0; i<n; i++,j++)
		if (str[i]=='\x0D')
		{
			point[j++]='\x0D';
			point[j]='\x0A';
		}
		else
			point[j]=pv2ansi[(unsigned char)str[i]];
	size=n2;
	return point;
}

char* win2pvEx(char* str, int& size)
{
	int n=size,i,j,n2,k,l;
	char* point;
	for(i=0,j=0,l=0; i<n; i++)
		if (str[i]=='\x0D'&&(i!=n-1)&&str[i+1]=='\x0A')
		{
			j++;
			i++;
			l=0;
		}
		else
			if (str[i]=='\x09')
			{
				j-=(7-l%8);
				l=0;
			}
			else
			{
				l++;
			}
	n2=n-j;
	point=new char[n2];
	for(i=0,j=0,l=0; i<n; i++)
		if (str[i]=='\x0D'&&(i!=n-1)&&str[i+1]=='\x0A')
		{
			point[j++]='\x0D';
			i++;
			l=0;
		}
		else
			if (str[i]=='\x09')
			{
				for(k=0; k<(8-l%8); k++)
					point[j+k]=' ';
				j+=(8-l%8);
				l=0;
			}
			else
			{
				point[j++]=ansi2pv[(unsigned char)str[i]];
				l++;
			}
	size=n2;
	return point;
}